Index: /trunk/kernel/fs/fatfs.c
===================================================================
--- /trunk/kernel/fs/fatfs.c	(revision 656)
+++ /trunk/kernel/fs/fatfs.c	(revision 657)
@@ -2105,6 +2644,6 @@
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_FATFS_UPDATE_DENTRY < cycle )
-printk("\n[%s]  thread[%x,%x] exit / updated size for <%s/%s> / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, dir_name, dentry->name, cycle );
+printk("\n[%s]  thread[%x,%x] exit for <%s> in <%s> directory / size %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, parent_name, child->name, new_size, cycle );
 #endif
 
@@ -2168,5 +2707,5 @@
     {
         // get one page from mapper
-        page_xp = mapper_remote_get_page( mapper_xp , page_id );
+        page_xp = mapper_get_page( mapper_xp , page_id );
 
         if( page_xp == XPTR_NULL) return -1;
@@ -2273,12 +2812,22 @@
 }  // end fatfs_get_user_dir()
 
-///////////////////////////////////////////////
-error_t fatfs_sync_inode( vfs_inode_t * inode )
-{
+///////////////////////////////////////////
+error_t fatfs_sync_inode( xptr_t inode_xp )
+{
+    cxy_t         inode_cxy;      // remote inode cluster
+    vfs_inode_t * inode_ptr;      // remote inode local pointer
+    mapper_t    * mapper;         // remote inode mapper local pointer
+    uint32_t      size;           // remote inode size in bytes
+    uint32_t      type;           // remote inode type
+    xptr_t        rt_xp;          // extended pointer on mapper radix tree
+    uint32_t      npages;         // number of pages in mapper
+    uint32_t      page_id;        // current page index in mapper
+    xptr_t        page_xp;        // extended pointer on current page
+    page_t      * page_ptr;       // local pointer on current page
+    uint32_t      flags;          // current page flags
+    error_t       error;
 
 // check inode pointer and cluster index
-assert( (inode != NULL)                  , "inode pointer undefined\n" );
-assert( (inode->mapper != NULL )         , "mapper pointer undefined\n" );
-assert( (inode->type == INODE_TYPE_FILE) , "inode must be a file\n" );     
+assert( (inode_xp != XPTR_NULL)          , "inode pointer undefined\n" );
 
 #if DEBUG_FATFS_SYNC_INODE
@@ -2286,5 +2835,5 @@
 uint32_t   cycle = (uint32_t)hal_get_cycles();
 thread_t * this  = CURRENT_THREAD;
-vfs_inode_get_name( XPTR( local_cxy , inode ) , name );
+vfs_inode_get_name( inode_xp , name );
 if( DEBUG_FATFS_SYNC_INODE < cycle )
 printk("\n[%s] thread[%x,%x] enter for <%s> / cycle %d\n",
@@ -2292,40 +2841,49 @@
 #endif
 
-    error_t    error;
-    mapper_t * mapper;
-    page_t   * page;
-    uint32_t   page_id;
-
-    // get mapper from inode 
-    mapper = inode->mapper;
-
-    // compute max number of pages in mapper from file size
-    uint32_t size  = inode->size;
-    uint32_t pages = size >> CONFIG_PPM_PAGE_SHIFT;
-    if( size & CONFIG_PPM_PAGE_MASK ) pages++; 
+    // get inode cluster and local pointer
+    inode_cxy = GET_CXY( inode_xp );
+    inode_ptr = GET_PTR( inode_xp );
+
+    //get inode mapper pointer
+    mapper    = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
+
+assert( (mapper != NULL) , "mapper pointer is NULL\n" );     
+
+    // get inode type and size
+    size = hal_remote_l32( XPTR( inode_cxy , &inode_ptr->size ) );
+    type = hal_remote_l32( XPTR( inode_cxy , &inode_ptr->type ) );
+
+assert( (type == INODE_TYPE_FILE) , "inode is not a file\n" );     
+
+    // compute number of pages
+    npages = size >> CONFIG_PPM_PAGE_SHIFT;
+    if( size & CONFIG_PPM_PAGE_MASK ) npages++; 
          
-    // get pointer on mapper radix tree
-    grdxt_t * rt = &mapper->rt;
+    // build pointers on mapper radix tree
+    rt_xp = XPTR( inode_cxy , &mapper->rt );
 
     // scan all pages
-    for( page_id = 0 ; page_id < pages ; page_id++ )
+    for( page_id = 0 ; page_id < npages ; page_id++ )
     {
         // get page descriptor from mapper
-        page = grdxt_lookup( rt , page_id );
+        page_xp = grdxt_remote_lookup( rt_xp , page_id );
 
         // check all existing pages
-        if ( page != NULL )
-        {
-            if ( page->flags & PG_DIRTY )
+        if ( page_xp != XPTR_NULL )
+        {
+            // get page cluster and local pointer
+            page_ptr = GET_PTR( page_xp );
+
+            // get page flags
+            flags = hal_remote_l32( XPTR( inode_cxy , &page_ptr->flags ) );
+   
+            if ( flags & PG_DIRTY )
             {
 
 #if (DEBUG_FATFS_SYNC_INODE & 1)
 if( DEBUG_FATFS_SYNC_INODE < cycle )
-printk("\n[%s] thread[%x,%x] synchronizes page %d from <%s> mapper to IOC device\n",
+printk("\n[%s] thread[%x,%x] synchronizes page %d of <%s> mapper to IOC device\n",
 __FUNCTION__, page_id, name );
 #endif
-                // build extended pointer on page descriptor
-                xptr_t page_xp = XPTR( local_cxy , page );
-
                 // move page from mapper to device
                 error = fatfs_move_page( page_xp , IOC_WRITE );
@@ -2342,6 +2900,6 @@
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_FATFS_SYNC_INODE < cycle )
-printk("\n[%s] thread[%x,%x] exit for <%s> / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, name, cycle );
+printk("\n[%s] thread[%x,%x] exit for <%s>\n",
+__FUNCTION__ , this->process->pid, this->trdid, name );
 #endif
 
@@ -2349,13 +2907,19 @@
 
 }  // end fatfs_sync_inode()
-
-
-
-
-
 
 //////////////////////////////
 error_t fatfs_sync_fat( void )
 {
+
+    fatfs_ctx_t * fatfs_ctx; 
+    cxy_t         fat_cxy;
+    mapper_t    * mapper_ptr;
+    xptr_t        mapper_xp;
+    uint32_t      start_page_id;
+    uint32_t      found_page_id;
+    page_t      * page_ptr;
+    xptr_t        page_xp;
+    uint32_t      flags;
+    error_t       error;
 
 #if DEBUG_FATFS_SYNC_FAT
@@ -2366,36 +2930,35 @@
 __FUNCTION__ , this->process->pid, this->trdid, cycle );
 #endif
-
-    uint32_t   page_id;
-    error_t    error;
-
-    // get FAT mapper pointers an cluster 
-    fatfs_ctx_t * fatfs_ctx  = fs_context[FS_TYPE_FATFS].extend;
-    xptr_t        mapper_xp  = fatfs_ctx->fat_mapper_xp;
-    cxy_t         mapper_cxy = GET_CXY( mapper_xp );
-    mapper_t    * mapper_ptr = GET_PTR( mapper_xp );
-
-    // compute max number of 4 Kbytes pages in FAT mapper 
-    // TODO : this could be improved (see fatfs.h) [AG]
-    uint32_t   pages = fatfs_ctx->fat_sectors_count >> 3;
-         
+    
+    // get FAT cluster
+    fat_cxy = CONFIG_VFS_ROOT_CXY;
+    
+    // get FAT mapper pointers  
+    fatfs_ctx  = fs_context[FS_TYPE_FATFS].extend;
+    mapper_ptr = fatfs_ctx->fat_mapper;
+    mapper_xp  = XPTR( fat_cxy , mapper_ptr );
+
     // get pointers on remote FAT mapper radix tree
     grdxt_t  * rt_ptr = &mapper_ptr->rt;
-    xptr_t     rt_xp  = XPTR( mapper_cxy , rt_ptr );
-
-    // scan all pages
-    for( page_id = 0 ; page_id < pages ; page_id++ )
-    {
-        // get extended pointer on page descriptor from FAT mapper
-        xptr_t page_xp = grdxt_remote_lookup( rt_xp , page_id );
-
-        // check all existing pages
-        if ( page_xp != XPTR_NULL )
-        {
-            page_t * page_ptr = GET_PTR( page_xp );
-            uint32_t flags    = hal_remote_l32( XPTR( mapper_cxy , &page_ptr->flags ) );
-
-            if ( flags & PG_DIRTY )
-            {
+    xptr_t     rt_xp  = XPTR( fat_cxy , rt_ptr );
+
+    // initialise page_id
+    start_page_id = 0;
+
+    // scan FAT mapper
+    while( 1 )
+    {
+        // get one page
+        page_xp = grdxt_remote_get_first( rt_xp , start_page_id , &found_page_id );
+
+        // exit loop when no more page found 
+        if ( page_xp != XPTR_NULL ) break;
+
+        // get page flags
+        page_ptr = GET_PTR( page_xp );
+        flags    = hal_remote_l32( XPTR( fat_cxy , &page_ptr->flags ) );
+
+        if ( flags & PG_DIRTY )
+        {
 
 #if (DEBUG_FATFS_SYNC_FAT & 1)
@@ -2404,13 +2967,16 @@
 __FUNCTION__, page_id );
 #endif
-                // move page from mapper to device
-                error = fatfs_move_page( page_xp , IOC_SYNC_WRITE );
-
-                if ( error )  return -1;
-
-                // reset page dirty flag
-                ppm_page_undo_dirty( page_xp );
-            }
-        }
+            // move page from mapper to device
+            error = fatfs_move_page( page_xp , IOC_SYNC_WRITE );
+
+            if ( error )  return -1;
+
+            // reset page dirty flag
+            ppm_page_undo_dirty( page_xp );
+        }
+
+        // update loop variable
+        start_page_id = found_page_id + 1;
+
     }  // end loop on pages
 
@@ -2418,6 +2984,6 @@
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_FATFS_SYNC_FAT < cycle )
-printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, cycle );
+printk("\n[%s] thread[%x,%x] exit\n",
+__FUNCTION__ , this->process->pid, this->trdid );
 #endif
 
@@ -2425,250 +2991,19 @@
 
 }  // end fatfs_sync_fat()
-
-////////////////////////////////////
-error_t fatfs_sync_free_info( void )
-{
-    error_t       error;
-    fatfs_ctx_t * fatfs_ctx_ptr;              // local pointer on fatfs context in cluster 0
-    uint32_t      ctx_free_clusters;          // number of free clusters from fatfs context
-    uint32_t      ctx_free_cluster_hint;      // free cluster hint from fatfs context
-    uint32_t      ioc_free_clusters;          // number of free clusters from fatfs context
-    uint32_t      ioc_free_cluster_hint;      // free cluster hint from fatfs context
-    uint32_t      fs_info_lba;                // lba of FS_INFO sector on IOC device
-    uint8_t     * fs_info_buffer;             // local pointer on FS_INFO buffer in cluster 0
-    xptr_t        fs_info_buffer_xp;          // extended pointer on FS_INFO buffer in cluster 0
-    uint8_t       tmp_buf[512];               // 512 bytes temporary buffer 
-    xptr_t        tmp_buf_xp;                 // extended pointer on temporary buffer
-
-#if DEBUG_FATFS_SYNC_FSINFO
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-thread_t * this  = CURRENT_THREAD;
-if( DEBUG_FATFS_SYNC_FSINFO < cycle )
-printk("\n[%s] thread[%x,%x] enter / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, cycle );
-#endif
-
-    // get pointer on fatfs context in cluster 0
-    fatfs_ctx_ptr = hal_remote_lpt( XPTR( 0 , &fs_context[FS_TYPE_FATFS].extend ) );
-
-    // get "free_clusters" and "free_cluster_hint" from fatfs context in cluster 0
-    ctx_free_clusters     = hal_remote_l32( XPTR( 0 , &fatfs_ctx_ptr->free_clusters ) );
-    ctx_free_cluster_hint = hal_remote_l32( XPTR( 0 , &fatfs_ctx_ptr->free_cluster_hint ) );
-
-    // get fs_info_lba 
-    fs_info_lba = hal_remote_l32( XPTR( 0 , &fatfs_ctx_ptr->fs_info_lba ) );
-
-    // build extended pointer on temporary buffer
-    tmp_buf_xp = XPTR( local_cxy , tmp_buf );
-
-    // copy FS_INFO sector from IOC to local buffer
-    error = dev_ioc_move_data( IOC_SYNC_READ , tmp_buf_xp , fs_info_lba , 1 );
-
-    if ( error )
-    {
-        printk("\n[ERROR] in %s : cannot access FS_INFO on IOC device\n", __FUNCTION__ );
-        return -1;
-    }
-
-    // get current values of "free_clusters" and "free_cluster_hint" from FS_INFO on IOC
-    ioc_free_clusters     = fatfs_get_remote_record( FS_FREE_CLUSTERS     , tmp_buf_xp );
-    ioc_free_cluster_hint = fatfs_get_remote_record( FS_FREE_CLUSTER_HINT , tmp_buf_xp );
-
-#if DEBUG_FATFS_SYNC_FSINFO
-if( DEBUG_FATFS_SYNC_FSINFO < cycle )
-printk("\n[%s] thread[%x,%x] / ctx_free %x / ioc_free %x / ctx_hint %x / ioc_hint %x\n",
-__FUNCTION__ , this->process->pid, this->trdid, 
-ctx_free_clusters, ioc_free_clusters, ctx_free_cluster_hint, ioc_free_cluster_hint );
-#endif
-
-    // check values
-    if( (ioc_free_clusters     != ctx_free_clusters) || 
-        (ioc_free_cluster_hint != ctx_free_cluster_hint) )
-    {
-        printk("\n[WARNING] in %s : unconsistent free clusters info\n"
-        " ioc_free %x / ctx_free %x / ioc_hint %x / ctx_hint %x\n",
-        __FUNCTION__, ioc_free_clusters, ctx_free_clusters,
-        ioc_free_cluster_hint, ctx_free_cluster_hint );
-
-        // get pointers on FS_INFO buffer in cluster 0
-        fs_info_buffer    = hal_remote_lpt( XPTR( 0 , &fatfs_ctx_ptr->fs_info_buffer ) );
-        fs_info_buffer_xp = XPTR( 0 , fs_info_buffer );
-
-        // update FS_INFO buffer in cluster 0 
-        fatfs_set_remote_record(FS_FREE_CLUSTERS    ,fs_info_buffer_xp,ctx_free_clusters );
-        fatfs_set_remote_record(FS_FREE_CLUSTER_HINT,fs_info_buffer_xp,ctx_free_cluster_hint);
-
-        // update the FS_INFO sector on IOC device
-        error = dev_ioc_move_data( IOC_SYNC_WRITE , fs_info_buffer_xp , fs_info_lba , 1 );
-
-        if ( error )
-        {
-            printk("\n[ERROR] in %s : cannot update FS_INFO on IOC device\n", __FUNCTION__ );
-            return -1;
-        }
-    }
-
-#if DEBUG_FATFS_SYNC_FSINFO
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_FATFS_SYNC_FSINFO < cycle )
-printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, cycle );
-#endif
-
-    return 0;
-
-}  // end fatfs_sync_free_info()
-
-//////////////////////////////////////////////////////////
-error_t fatfs_cluster_alloc( uint32_t * searched_cluster )
-{
-    error_t       error;
-    uint32_t      page_id;        // page index in FAT mapper
-    uint32_t      slot_id;        // slot index in page (1024 slots per page)
-    uint32_t      cluster;        // first free cluster index in FAT
-    uint32_t      free_clusters;  // total number of free clusters
-    vfs_ctx_t   * vfs_ctx;        // local pointer on VFS context (same in all clusters)
-    fatfs_ctx_t * loc_fatfs_ctx;  // local pointer on local FATFS context
-    fatfs_ctx_t * fat_fatfs_ctx;  // local pointer on FATFS context in FAT cluster
-    xptr_t        fat_mapper_xp;  // extended pointer on FAT mapper
-    cxy_t         fat_cxy;        // Fat mapper cluster identifier
-    xptr_t        page_xp;        // extended pointer on current page descriptor in mapper
-    xptr_t        slot_xp;        // extended pointer on FAT slot defined by hint
-    xptr_t        lock_xp;        // extended pointer on lock protecting free clusters info
-    xptr_t        hint_xp;        // extended pointer on free_cluster_hint in FAT cluster
-    xptr_t        free_xp;        // extended pointer on free_clusters_number in FAT cluster
-
-#if DEBUG_FATFS_CLUSTER_ALLOC
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-thread_t * this  = CURRENT_THREAD;
-if( DEBUG_FATFS_CLUSTER_ALLOC < cycle )
-printk("\n[%s] thread[%x,%x] enter / cycle = %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-
-    // get local pointer on VFS context (same in all clusters)
-    vfs_ctx = &fs_context[FS_TYPE_FATFS];
-
-    // get local pointer on local FATFS context
-    loc_fatfs_ctx = vfs_ctx->extend;
-
-    // get extended pointer on FAT mapper
-    fat_mapper_xp  = loc_fatfs_ctx->fat_mapper_xp;
-
-    // get FAT cluster
-    fat_cxy = GET_CXY( fat_mapper_xp );
-    
-    // get local pointer on FATFS context in FAT cluster 
-    fat_fatfs_ctx = hal_remote_lpt( XPTR( fat_cxy , &vfs_ctx->extend ) );
-
-    // build relevant extended pointers on free clusters info in mapper cluster 
-    lock_xp = XPTR( fat_cxy , &fat_fatfs_ctx->lock );
-    hint_xp = XPTR( fat_cxy , &fat_fatfs_ctx->free_cluster_hint );
-    free_xp = XPTR( fat_cxy , &fat_fatfs_ctx->free_clusters );
-
-    // take the FAT lock in write mode
-    remote_rwlock_wr_acquire( lock_xp );
-
-    // get hint and free_clusters values from FATFS context in FAT cluster
-    cluster       = hal_remote_l32( hint_xp ) + 1;
-    free_clusters = hal_remote_l32( free_xp );
-        
-#if (DEBUG_FATFS_CLUSTER_ALLOC & 1)
-if( DEBUG_FATFS_CLUSTER_ALLOC < cycle )
-printk("\n[%s] thread[%x,%x] get free info : hint %x / free_clusters %x\n",
-__FUNCTION__, this->process->pid, this->trdid, (cluster - 1), free_clusters );
-#endif
-
-    // check "free_clusters"
-    if ( free_clusters == 0 )
-    {
-        printk("\n[ERROR] in %s : no more free FATFS clusters\n", __FUNCTION__ );
-        remote_rwlock_wr_release( lock_xp );
-        return -1;
-    }
-    else if ( free_clusters < CONFIG_VFS_FREE_CLUSTERS_MIN )
-    {
-        printk("\n[WARNING] in %s : only %n free FATFS clusters\n", 
-        __FUNCTION__, CONFIG_VFS_FREE_CLUSTERS_MIN );
-    }
-
-    // get page index & slot index for selected cluster 
-    page_id  = cluster >> 10;
-    slot_id  = cluster & 0x3FF;
-
-    // get relevant page descriptor from FAT mapper
-    page_xp = mapper_remote_get_page( fat_mapper_xp , page_id );
-
-    if( page_xp == XPTR_NULL )
-    {
-        printk("\n[ERROR] in %s : cannot acces FAT mapper\n", __FUNCTION__ );
-        remote_rwlock_wr_release( lock_xp );
-        return -1;
-    }
-
-    // build extended pointer on selected cluster slot in FAT mapper
-    slot_xp = ppm_page2base( page_xp ) + (slot_id << 2);
-         
-    // check selected cluster actually free
-    if( hal_remote_l32( slot_xp ) != FREE_CLUSTER )
-    { 
-        printk("\n[ERROR] in %s : selected cluster %x not free\n", __FUNCTION__, cluster );
-        remote_rwlock_wr_release( lock_xp );
-        return -1;
-    }
-
-    // update free cluster info in FATFS context and in FS_INFO sector
-    error = fatfs_free_clusters_decrement( XPTR( fat_cxy , fat_fatfs_ctx ) , cluster );
-
-    if( error )
-    { 
-        printk("\n[ERROR] in %s : cannot update free cluster info\n", __FUNCTION__ );
-        remote_rwlock_wr_release( lock_xp );
-        return -1;
-    }
-
-    // update FAT mapper
-    hal_remote_s32( slot_xp , END_OF_CHAIN_CLUSTER_MAX );
-
-    // we don't mark the FAT mapper page as dirty,
-    // because we synchronously update FAT on IOC device
-    error = fatfs_move_page( page_xp , IOC_SYNC_WRITE );
-
-    if( error )
-    { 
-        printk("\n[ERROR] in %s : cannot update FAT on IOC device\n", __FUNCTION__ );
-        remote_rwlock_wr_release( lock_xp );
-        return -1;
-    }
-
-    // release FAT lock
-    remote_rwlock_wr_release( lock_xp );
-
-#if DEBUG_FATFS_CLUSTER_ALLOC 
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_FATFS_CLUSTER_ALLOC < cycle )
-printk("\n[%s] thread[%x,%x] exit / allocated cluster %x in FAT / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cluster, cycle );
-#endif
-
-    *searched_cluster = cluster;
-    return 0;
-
-}  // end fatfs_cluster_alloc()
 
 //////////////////////////////////////////////
 error_t fatfs_release_inode( xptr_t inode_xp )
 {
-    vfs_ctx_t   * vfs_ctx;        // local pointer on VFS context (same in all clusters).
-    fatfs_ctx_t * loc_fatfs_ctx;  // local pointer on local FATFS context
-    cxy_t         fat_cxy;        // FAT cluster identifier
-    xptr_t        fatfs_ctx_xp;   // extended pointer on FATFS context in FAT cluster
-    fatfs_ctx_t * fatfs_ctx_ptr;  // local pointer on FATFS context in FAT cluster
-    xptr_t        fat_mapper_xp;  // extended pointer on FAT mapper
-    xptr_t        lock_xp;        // extended pointer on lock protecting FAT.
-    xptr_t        first_xp;       // extended pointer on inode extension
-    uint32_t      first_cluster;  // first cluster index for released inode
-    vfs_inode_t * inode_ptr;      // local pointer on target inode
-    cxy_t         inode_cxy;      // target inode cluster identifier
+    vfs_ctx_t   * vfs_ctx;           // local pointer on VFS context (same in all clusters)
+    cxy_t         fat_cxy;           // FAT cluster identifier
+    fatfs_ctx_t * fatfs_ctx_ptr;     // local pointer on FATFS context in FAT cluster
+    xptr_t        fatfs_ctx_xp;      // extended pointer on FATFS-context in FAT cluster
+    mapper_t    * fat_mapper_ptr;    // local pointer on FAT mapper
+    xptr_t        fat_mapper_xp;     // extended pointer on FAT mapper
+    xptr_t        lock_xp;           // extended pointer on lock protecting FAT.
+    xptr_t        first_xp;          // extended pointer on inode extension
+    uint32_t      first_cluster_id;  // first cluster index for released inode
+    vfs_inode_t * inode_ptr;         // local pointer on target inode
+    cxy_t         inode_cxy;         // target inode cluster identifier
     error_t       error;
 
@@ -2680,10 +3015,10 @@
     inode_cxy     = GET_CXY( inode_xp );
 
-    // get first_cluster from inode extension
-    first_xp      = XPTR( inode_cxy , &inode_ptr->extend );
-    first_cluster = (uint32_t)(intptr_t)hal_remote_lpt( first_xp );
+    // get first_cluster_id from inode extension
+    first_xp         = XPTR( inode_cxy , &inode_ptr->extend );
+    first_cluster_id = (uint32_t)(intptr_t)hal_remote_lpt( first_xp );
 
 // check first cluster index
-assert( (first_cluster != 0) , "inode extend is NULL\n" );
+assert( (first_cluster_id != 0) , "inode extend is NULL\n" );
 
 #if DEBUG_FATFS_RELEASE_INODE
@@ -2693,6 +3028,6 @@
 vfs_inode_get_name( inode_xp , name );
 if( DEBUG_FATFS_RELEASE_INODE < cycle )
-printk("\n[%s] thread[%x,%x] enter for <%s> / first_cluster %x / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, name, first_cluster, cycle );
+printk("\n[%s] thread[%x,%x] enter for <%s> / first_cluster_id %x / cycle %d\n",
+__FUNCTION__ , this->process->pid, this->trdid, name, first_cluster_id, cycle );
 #endif
 
@@ -2700,16 +3035,16 @@
     vfs_ctx = &fs_context[FS_TYPE_FATFS];
 
-    // get local pointer on local FATFS context
-    loc_fatfs_ctx = vfs_ctx->extend;
-
-    // get FAT mapper cluster
-    fat_mapper_xp  = loc_fatfs_ctx->fat_mapper_xp;
-    fat_cxy        = GET_CXY( fat_mapper_xp );
+    // get FAT cluster
+    fat_cxy = CONFIG_VFS_ROOT_CXY;
+
+    // get pointers on FATFS context in FAT cluster 
+    fatfs_ctx_ptr = hal_remote_lpt( XPTR( fat_cxy , &vfs_ctx->extend ) );
+    fatfs_ctx_xp  = XPTR( fat_cxy , fatfs_ctx_ptr ); 
+
+    // get FAT mapper pointers
+    fat_mapper_ptr = hal_remote_lpt( XPTR( fat_cxy , &fatfs_ctx_ptr->fat_mapper ) );
+	fat_mapper_xp  = XPTR( fat_cxy , fat_mapper_ptr );
     
-    // get pointers on FATFS context in FAT cluster 
-    fatfs_ctx_ptr  = hal_remote_lpt( XPTR( fat_cxy , &vfs_ctx->extend ) );
-    fatfs_ctx_xp   = XPTR( fat_cxy , fatfs_ctx_ptr );
-
-    // get extended pointer on FAT lock in FAT cluster
+    // build extended pointer on FAT lock in FAT cluster
     lock_xp = XPTR( fat_cxy , &fatfs_ctx_ptr->lock );
 
@@ -2727,5 +3062,5 @@
     if ( fatfs_recursive_release( fat_mapper_xp,
                                   fatfs_ctx_xp,
-                                  first_cluster,
+                                  first_cluster_id,
                                   &dirty_page_min,
                                   &dirty_page_max ) )
@@ -2791,9 +3126,10 @@
 }  // end fatfs_release_inode()
 
-////////////////////////////////////////////
-error_t fatfs_move_page( xptr_t     page_xp,
-                         cmd_type_t cmd_type )
-{
-    error_t       error;
+/////////////////////////////////////////////////
+error_t fatfs_move_page( xptr_t          page_xp,
+                         ioc_cmd_type_t  cmd_type )
+{
+    error_t       error = 0;
+
     vfs_inode_t * inode_ptr;
     mapper_t    * mapper_ptr;      
@@ -2829,5 +3165,5 @@
 #if DEBUG_FATFS_MOVE_PAGE
 if( DEBUG_FATFS_MOVE_PAGE < cycle )
-printk("\n[%s] thread[%x,%x] enters for %s /  page %d in FAT mapper / cycle %d\n",
+printk("\n[%s] thread[%x,%x] enters %s for  page %d in FAT mapper / cycle %d\n",
 __FUNCTION__, this->process->pid, this->trdid, dev_ioc_cmd_str(cmd_type), page_id, cycle );
 #endif
@@ -2836,9 +3172,14 @@
  
         // access IOC device
-        error = dev_ioc_move_data( cmd_type , buffer_xp , lba , 8 );
+        if     (cmd_type == IOC_SYNC_WRITE) error = dev_ioc_sync_write( buffer_xp, lba, 8 );
+        else if(cmd_type == IOC_SYNC_READ ) error = dev_ioc_sync_read( buffer_xp, lba, 8 );
+        else
+        {
+            printk("\n[ERROR] in %s : illegal asynchronous FAT access\n", __FUNCTION__ );
+        }
 
         if( error )
         {
-            printk("\n[ERROR] in %s : cannot access device\n", __FUNCTION__ );
+            printk("\n[ERROR] in %s : cannot access IOC device\n", __FUNCTION__ );
             return -1;
         }
@@ -2846,6 +3187,6 @@
 #if DEBUG_FATFS_MOVE_PAGE
 if( DEBUG_FATFS_MOVE_PAGE < cycle )
-printk("\n[%s] thread[%x,%x] exit / page %d in FAT mapper\n",
-__FUNCTION__, this->process->pid, this->trdid, page_id, cycle );
+printk("\n[%s] thread[%x,%x] exit %s for page %d in FAT mapper\n",
+__FUNCTION__, this->process->pid, this->trdid, dev_ioc_cmd_str(cmd_type), page_id );
 #endif
 
@@ -2856,9 +3197,11 @@
 
 #if DEBUG_FATFS_MOVE_PAGE
-vfs_inode_get_name( XPTR( page_cxy , inode_ptr ) , name );
 if( DEBUG_FATFS_MOVE_PAGE < cycle )
-printk("\n[%s] thread[%x,%x] enters for %s / page %d in <%s> mapper/ cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-dev_ioc_cmd_str( cmd_type ), page_id, name, cycle );
+{
+    vfs_inode_get_name( XPTR( page_cxy , inode_ptr ) , name );
+    printk("\n[%s] thread[%x,%x] enters %s for page %d in <%s> mapper / cycle %d\n",
+    __FUNCTION__, this->process->pid, this->trdid, 
+    dev_ioc_cmd_str( cmd_type ), page_id, name, cycle );
+}
 #endif
 
@@ -2893,6 +3236,13 @@
         uint32_t lba = fatfs_lba_from_cluster( fatfs_ctx , searched_cluster_id );
 
-        // access IOC device to move 8 blocks
-        error = dev_ioc_move_data( cmd_type , buffer_xp , lba , 8 );
+        // access IOC device
+        if     (cmd_type == IOC_WRITE     ) error = dev_ioc_write( buffer_xp, lba, 8 );
+        else if(cmd_type == IOC_READ      ) error = dev_ioc_read( buffer_xp, lba, 8 );
+        else if(cmd_type == IOC_SYNC_READ ) error = dev_ioc_sync_read( buffer_xp, lba, 8 );
+        else if(cmd_type == IOC_SYNC_WRITE) error = dev_ioc_sync_write( buffer_xp, lba, 8 );
+        else
+        {
+            printk("\n[ERROR] in %s : illegal cmd_type\n", __FUNCTION__ );
+        }
 
         if( error )
@@ -2904,7 +3254,14 @@
 #if DEBUG_FATFS_MOVE_PAGE
 if( DEBUG_FATFS_MOVE_PAGE < cycle )
-vfs_inode_get_name( XPTR( page_cxy, inode_ptr ) , name );
-printk("\n[%s] thread[%x,%x] exit / page %d in <%s> mapper / cluster_id %x\n",
-__FUNCTION__, this->process->pid, this->trdid, page_id, name, searched_cluster_id );
+{
+    printk("\n[%s] thread[%x,%x] exit %s for page %d in <%s> mapper / cluster_id %x\n",
+    __FUNCTION__, this->process->pid, this->trdid, 
+    dev_ioc_cmd_str( cmd_type ), page_id, name, searched_cluster_id );
+}
+#endif
+
+#if (DEBUG_FATFS_MOVE_PAGE & 1)
+if( DEBUG_FATFS_MOVE_PAGE < cycle )
+fatfs_display_fat( searched_cluster_id , 64 );
 #endif
 
